// Code generated by mockery v2.33.3. DO NOT EDIT.

package mocks

import (
	common "gitlab.com/cyverse/cacao-common/common"
	http "gitlab.com/cyverse/cacao-common/http"

	mock "github.com/stretchr/testify/mock"

	service "gitlab.com/cyverse/cacao-common/service"

	templates "gitlab.com/cyverse/cacao/api-service/clients/templates"
)

// Session is an autogenerated mock type for the Session type
type Session struct {
	mock.Mock
}

// CreateTemplateCustomFieldType provides a mock function with given fields: creationRequest
func (_m *Session) CreateTemplateCustomFieldType(creationRequest http.TemplateCustomFieldType) (string, error) {
	ret := _m.Called(creationRequest)

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(http.TemplateCustomFieldType) (string, error)); ok {
		return rf(creationRequest)
	}
	if rf, ok := ret.Get(0).(func(http.TemplateCustomFieldType) string); ok {
		r0 = rf(creationRequest)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(http.TemplateCustomFieldType) error); ok {
		r1 = rf(creationRequest)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateTemplateType provides a mock function with given fields: creationRequest
func (_m *Session) CreateTemplateType(creationRequest http.TemplateType) (service.TemplateTypeName, error) {
	ret := _m.Called(creationRequest)

	var r0 service.TemplateTypeName
	var r1 error
	if rf, ok := ret.Get(0).(func(http.TemplateType) (service.TemplateTypeName, error)); ok {
		return rf(creationRequest)
	}
	if rf, ok := ret.Get(0).(func(http.TemplateType) service.TemplateTypeName); ok {
		r0 = rf(creationRequest)
	} else {
		r0 = ret.Get(0).(service.TemplateTypeName)
	}

	if rf, ok := ret.Get(1).(func(http.TemplateType) error); ok {
		r1 = rf(creationRequest)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateTemplateWebhook provides a mock function with given fields: request
func (_m *Session) CreateTemplateWebhook(request service.TemplateWebhook) (templates.TemplateWebhook, error) {
	ret := _m.Called(request)

	var r0 templates.TemplateWebhook
	var r1 error
	if rf, ok := ret.Get(0).(func(service.TemplateWebhook) (templates.TemplateWebhook, error)); ok {
		return rf(request)
	}
	if rf, ok := ret.Get(0).(func(service.TemplateWebhook) templates.TemplateWebhook); ok {
		r0 = rf(request)
	} else {
		r0 = ret.Get(0).(templates.TemplateWebhook)
	}

	if rf, ok := ret.Get(1).(func(service.TemplateWebhook) error); ok {
		r1 = rf(request)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteTemplate provides a mock function with given fields: templateID
func (_m *Session) DeleteTemplate(templateID common.ID) (common.ID, error) {
	ret := _m.Called(templateID)

	var r0 common.ID
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) (common.ID, error)); ok {
		return rf(templateID)
	}
	if rf, ok := ret.Get(0).(func(common.ID) common.ID); ok {
		r0 = rf(templateID)
	} else {
		r0 = ret.Get(0).(common.ID)
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(templateID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteTemplateCustomFieldType provides a mock function with given fields: templateCustomFieldTypeName
func (_m *Session) DeleteTemplateCustomFieldType(templateCustomFieldTypeName string) (string, error) {
	ret := _m.Called(templateCustomFieldTypeName)

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(string) (string, error)); ok {
		return rf(templateCustomFieldTypeName)
	}
	if rf, ok := ret.Get(0).(func(string) string); ok {
		r0 = rf(templateCustomFieldTypeName)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(templateCustomFieldTypeName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteTemplateType provides a mock function with given fields: templateTypeName
func (_m *Session) DeleteTemplateType(templateTypeName service.TemplateTypeName) (service.TemplateTypeName, error) {
	ret := _m.Called(templateTypeName)

	var r0 service.TemplateTypeName
	var r1 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName) (service.TemplateTypeName, error)); ok {
		return rf(templateTypeName)
	}
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName) service.TemplateTypeName); ok {
		r0 = rf(templateTypeName)
	} else {
		r0 = ret.Get(0).(service.TemplateTypeName)
	}

	if rf, ok := ret.Get(1).(func(service.TemplateTypeName) error); ok {
		r1 = rf(templateTypeName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteTemplateWebhook provides a mock function with given fields: templateID
func (_m *Session) DeleteTemplateWebhook(templateID common.ID) error {
	ret := _m.Called(templateID)

	var r0 error
	if rf, ok := ret.Get(0).(func(common.ID) error); ok {
		r0 = rf(templateID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetTemplate provides a mock function with given fields: templateID
func (_m *Session) GetTemplate(templateID common.ID) (http.Template, error) {
	ret := _m.Called(templateID)

	var r0 http.Template
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) (http.Template, error)); ok {
		return rf(templateID)
	}
	if rf, ok := ret.Get(0).(func(common.ID) http.Template); ok {
		r0 = rf(templateID)
	} else {
		r0 = ret.Get(0).(http.Template)
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(templateID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetTemplateCustomFieldType provides a mock function with given fields: templateCustomFieldTypeName
func (_m *Session) GetTemplateCustomFieldType(templateCustomFieldTypeName string) (http.TemplateCustomFieldType, error) {
	ret := _m.Called(templateCustomFieldTypeName)

	var r0 http.TemplateCustomFieldType
	var r1 error
	if rf, ok := ret.Get(0).(func(string) (http.TemplateCustomFieldType, error)); ok {
		return rf(templateCustomFieldTypeName)
	}
	if rf, ok := ret.Get(0).(func(string) http.TemplateCustomFieldType); ok {
		r0 = rf(templateCustomFieldTypeName)
	} else {
		r0 = ret.Get(0).(http.TemplateCustomFieldType)
	}

	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(templateCustomFieldTypeName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetTemplateType provides a mock function with given fields: templateTypeName
func (_m *Session) GetTemplateType(templateTypeName service.TemplateTypeName) (http.TemplateType, error) {
	ret := _m.Called(templateTypeName)

	var r0 http.TemplateType
	var r1 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName) (http.TemplateType, error)); ok {
		return rf(templateTypeName)
	}
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName) http.TemplateType); ok {
		r0 = rf(templateTypeName)
	} else {
		r0 = ret.Get(0).(http.TemplateType)
	}

	if rf, ok := ret.Get(1).(func(service.TemplateTypeName) error); ok {
		r1 = rf(templateTypeName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetTemplateVersion provides a mock function with given fields: templateVersionID
func (_m *Session) GetTemplateVersion(templateVersionID common.ID) (http.TemplateVersion, error) {
	ret := _m.Called(templateVersionID)

	var r0 http.TemplateVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) (http.TemplateVersion, error)); ok {
		return rf(templateVersionID)
	}
	if rf, ok := ret.Get(0).(func(common.ID) http.TemplateVersion); ok {
		r0 = rf(templateVersionID)
	} else {
		r0 = ret.Get(0).(http.TemplateVersion)
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(templateVersionID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ImportTemplate provides a mock function with given fields: importRequest, credentialID
func (_m *Session) ImportTemplate(importRequest http.Template, credentialID string) (common.ID, error) {
	ret := _m.Called(importRequest, credentialID)

	var r0 common.ID
	var r1 error
	if rf, ok := ret.Get(0).(func(http.Template, string) (common.ID, error)); ok {
		return rf(importRequest, credentialID)
	}
	if rf, ok := ret.Get(0).(func(http.Template, string) common.ID); ok {
		r0 = rf(importRequest, credentialID)
	} else {
		r0 = ret.Get(0).(common.ID)
	}

	if rf, ok := ret.Get(1).(func(http.Template, string) error); ok {
		r1 = rf(importRequest, credentialID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListPublicTemplates provides a mock function with given fields:
func (_m *Session) ListPublicTemplates() ([]templates.PublicTemplate, error) {
	ret := _m.Called()

	var r0 []templates.PublicTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func() ([]templates.PublicTemplate, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() []templates.PublicTemplate); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]templates.PublicTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplateCustomFieldTypes provides a mock function with given fields:
func (_m *Session) ListTemplateCustomFieldTypes() ([]http.TemplateCustomFieldType, error) {
	ret := _m.Called()

	var r0 []http.TemplateCustomFieldType
	var r1 error
	if rf, ok := ret.Get(0).(func() ([]http.TemplateCustomFieldType, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() []http.TemplateCustomFieldType); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]http.TemplateCustomFieldType)
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplateSourceTypes provides a mock function with given fields:
func (_m *Session) ListTemplateSourceTypes() ([]service.TemplateSourceType, error) {
	ret := _m.Called()

	var r0 []service.TemplateSourceType
	var r1 error
	if rf, ok := ret.Get(0).(func() ([]service.TemplateSourceType, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() []service.TemplateSourceType); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]service.TemplateSourceType)
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplateTypes provides a mock function with given fields:
func (_m *Session) ListTemplateTypes() ([]http.TemplateType, error) {
	ret := _m.Called()

	var r0 []http.TemplateType
	var r1 error
	if rf, ok := ret.Get(0).(func() ([]http.TemplateType, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() []http.TemplateType); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]http.TemplateType)
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplateTypesForProvideType provides a mock function with given fields: providerType
func (_m *Session) ListTemplateTypesForProvideType(providerType service.TemplateProviderType) ([]http.TemplateType, error) {
	ret := _m.Called(providerType)

	var r0 []http.TemplateType
	var r1 error
	if rf, ok := ret.Get(0).(func(service.TemplateProviderType) ([]http.TemplateType, error)); ok {
		return rf(providerType)
	}
	if rf, ok := ret.Get(0).(func(service.TemplateProviderType) []http.TemplateType); ok {
		r0 = rf(providerType)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]http.TemplateType)
		}
	}

	if rf, ok := ret.Get(1).(func(service.TemplateProviderType) error); ok {
		r1 = rf(providerType)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplateVersions provides a mock function with given fields: templateID
func (_m *Session) ListTemplateVersions(templateID common.ID) ([]http.TemplateVersion, error) {
	ret := _m.Called(templateID)

	var r0 []http.TemplateVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) ([]http.TemplateVersion, error)); ok {
		return rf(templateID)
	}
	if rf, ok := ret.Get(0).(func(common.ID) []http.TemplateVersion); ok {
		r0 = rf(templateID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]http.TemplateVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(templateID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplateWebhooks provides a mock function with given fields:
func (_m *Session) ListTemplateWebhooks() ([]service.TemplateWebhook, error) {
	ret := _m.Called()

	var r0 []service.TemplateWebhook
	var r1 error
	if rf, ok := ret.Get(0).(func() ([]service.TemplateWebhook, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() []service.TemplateWebhook); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]service.TemplateWebhook)
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListTemplates provides a mock function with given fields: includeCacaoReservedPurposes
func (_m *Session) ListTemplates(includeCacaoReservedPurposes bool) ([]http.Template, error) {
	ret := _m.Called(includeCacaoReservedPurposes)

	var r0 []http.Template
	var r1 error
	if rf, ok := ret.Get(0).(func(bool) ([]http.Template, error)); ok {
		return rf(includeCacaoReservedPurposes)
	}
	if rf, ok := ret.Get(0).(func(bool) []http.Template); ok {
		r0 = rf(includeCacaoReservedPurposes)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]http.Template)
		}
	}

	if rf, ok := ret.Get(1).(func(bool) error); ok {
		r1 = rf(includeCacaoReservedPurposes)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// QueryTemplateCustomFieldType provides a mock function with given fields: templateCustomFieldTypeName, queryParams
func (_m *Session) QueryTemplateCustomFieldType(templateCustomFieldTypeName string, queryParams map[string]string) (http.TemplateCustomFieldTypeQueryResult, error) {
	ret := _m.Called(templateCustomFieldTypeName, queryParams)

	var r0 http.TemplateCustomFieldTypeQueryResult
	var r1 error
	if rf, ok := ret.Get(0).(func(string, map[string]string) (http.TemplateCustomFieldTypeQueryResult, error)); ok {
		return rf(templateCustomFieldTypeName, queryParams)
	}
	if rf, ok := ret.Get(0).(func(string, map[string]string) http.TemplateCustomFieldTypeQueryResult); ok {
		r0 = rf(templateCustomFieldTypeName, queryParams)
	} else {
		r0 = ret.Get(0).(http.TemplateCustomFieldTypeQueryResult)
	}

	if rf, ok := ret.Get(1).(func(string, map[string]string) error); ok {
		r1 = rf(templateCustomFieldTypeName, queryParams)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SyncTemplate provides a mock function with given fields: templateID, credentialID
func (_m *Session) SyncTemplate(templateID common.ID, credentialID string) (common.ID, error) {
	ret := _m.Called(templateID, credentialID)

	var r0 common.ID
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID, string) (common.ID, error)); ok {
		return rf(templateID, credentialID)
	}
	if rf, ok := ret.Get(0).(func(common.ID, string) common.ID); ok {
		r0 = rf(templateID, credentialID)
	} else {
		r0 = ret.Get(0).(common.ID)
	}

	if rf, ok := ret.Get(1).(func(common.ID, string) error); ok {
		r1 = rf(templateID, credentialID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateTemplate provides a mock function with given fields: templateID, updateRequest
func (_m *Session) UpdateTemplate(templateID common.ID, updateRequest http.Template) (common.ID, error) {
	ret := _m.Called(templateID, updateRequest)

	var r0 common.ID
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID, http.Template) (common.ID, error)); ok {
		return rf(templateID, updateRequest)
	}
	if rf, ok := ret.Get(0).(func(common.ID, http.Template) common.ID); ok {
		r0 = rf(templateID, updateRequest)
	} else {
		r0 = ret.Get(0).(common.ID)
	}

	if rf, ok := ret.Get(1).(func(common.ID, http.Template) error); ok {
		r1 = rf(templateID, updateRequest)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateTemplateCustomFieldType provides a mock function with given fields: templateCustomFieldTypeName, updateRequest
func (_m *Session) UpdateTemplateCustomFieldType(templateCustomFieldTypeName string, updateRequest http.TemplateCustomFieldType) (string, error) {
	ret := _m.Called(templateCustomFieldTypeName, updateRequest)

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(string, http.TemplateCustomFieldType) (string, error)); ok {
		return rf(templateCustomFieldTypeName, updateRequest)
	}
	if rf, ok := ret.Get(0).(func(string, http.TemplateCustomFieldType) string); ok {
		r0 = rf(templateCustomFieldTypeName, updateRequest)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(string, http.TemplateCustomFieldType) error); ok {
		r1 = rf(templateCustomFieldTypeName, updateRequest)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateTemplateCustomFieldTypeFields provides a mock function with given fields: templateCustomFieldTypeName, updateRequest, updateFields
func (_m *Session) UpdateTemplateCustomFieldTypeFields(templateCustomFieldTypeName string, updateRequest http.TemplateCustomFieldType, updateFields []string) (string, error) {
	ret := _m.Called(templateCustomFieldTypeName, updateRequest, updateFields)

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(string, http.TemplateCustomFieldType, []string) (string, error)); ok {
		return rf(templateCustomFieldTypeName, updateRequest, updateFields)
	}
	if rf, ok := ret.Get(0).(func(string, http.TemplateCustomFieldType, []string) string); ok {
		r0 = rf(templateCustomFieldTypeName, updateRequest, updateFields)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(string, http.TemplateCustomFieldType, []string) error); ok {
		r1 = rf(templateCustomFieldTypeName, updateRequest, updateFields)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateTemplateFields provides a mock function with given fields: templateID, updateRequest, updateFields
func (_m *Session) UpdateTemplateFields(templateID common.ID, updateRequest http.Template, updateFields []string) (common.ID, error) {
	ret := _m.Called(templateID, updateRequest, updateFields)

	var r0 common.ID
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID, http.Template, []string) (common.ID, error)); ok {
		return rf(templateID, updateRequest, updateFields)
	}
	if rf, ok := ret.Get(0).(func(common.ID, http.Template, []string) common.ID); ok {
		r0 = rf(templateID, updateRequest, updateFields)
	} else {
		r0 = ret.Get(0).(common.ID)
	}

	if rf, ok := ret.Get(1).(func(common.ID, http.Template, []string) error); ok {
		r1 = rf(templateID, updateRequest, updateFields)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateTemplateType provides a mock function with given fields: templateTypeName, updateRequest
func (_m *Session) UpdateTemplateType(templateTypeName service.TemplateTypeName, updateRequest http.TemplateType) (service.TemplateTypeName, error) {
	ret := _m.Called(templateTypeName, updateRequest)

	var r0 service.TemplateTypeName
	var r1 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName, http.TemplateType) (service.TemplateTypeName, error)); ok {
		return rf(templateTypeName, updateRequest)
	}
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName, http.TemplateType) service.TemplateTypeName); ok {
		r0 = rf(templateTypeName, updateRequest)
	} else {
		r0 = ret.Get(0).(service.TemplateTypeName)
	}

	if rf, ok := ret.Get(1).(func(service.TemplateTypeName, http.TemplateType) error); ok {
		r1 = rf(templateTypeName, updateRequest)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateTemplateTypeFields provides a mock function with given fields: templateTypeName, updateRequest, updateFields
func (_m *Session) UpdateTemplateTypeFields(templateTypeName service.TemplateTypeName, updateRequest http.TemplateType, updateFields []string) (service.TemplateTypeName, error) {
	ret := _m.Called(templateTypeName, updateRequest, updateFields)

	var r0 service.TemplateTypeName
	var r1 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName, http.TemplateType, []string) (service.TemplateTypeName, error)); ok {
		return rf(templateTypeName, updateRequest, updateFields)
	}
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName, http.TemplateType, []string) service.TemplateTypeName); ok {
		r0 = rf(templateTypeName, updateRequest, updateFields)
	} else {
		r0 = ret.Get(0).(service.TemplateTypeName)
	}

	if rf, ok := ret.Get(1).(func(service.TemplateTypeName, http.TemplateType, []string) error); ok {
		r1 = rf(templateTypeName, updateRequest, updateFields)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ValidateTemplateCustomFieldTypeCreationRequest provides a mock function with given fields: creationRequest
func (_m *Session) ValidateTemplateCustomFieldTypeCreationRequest(creationRequest http.TemplateCustomFieldType) error {
	ret := _m.Called(creationRequest)

	var r0 error
	if rf, ok := ret.Get(0).(func(http.TemplateCustomFieldType) error); ok {
		r0 = rf(creationRequest)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateCustomFieldTypeDeletionRequest provides a mock function with given fields: templateCustomFieldTypeName
func (_m *Session) ValidateTemplateCustomFieldTypeDeletionRequest(templateCustomFieldTypeName string) error {
	ret := _m.Called(templateCustomFieldTypeName)

	var r0 error
	if rf, ok := ret.Get(0).(func(string) error); ok {
		r0 = rf(templateCustomFieldTypeName)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateCustomFieldTypeUpdateFieldsRequest provides a mock function with given fields: templateCustomFieldTypeName, updateRequest, updateFields
func (_m *Session) ValidateTemplateCustomFieldTypeUpdateFieldsRequest(templateCustomFieldTypeName string, updateRequest http.TemplateCustomFieldType, updateFields []string) error {
	ret := _m.Called(templateCustomFieldTypeName, updateRequest, updateFields)

	var r0 error
	if rf, ok := ret.Get(0).(func(string, http.TemplateCustomFieldType, []string) error); ok {
		r0 = rf(templateCustomFieldTypeName, updateRequest, updateFields)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateCustomFieldTypeUpdateRequest provides a mock function with given fields: templateCustomFieldTypeName, updateRequest
func (_m *Session) ValidateTemplateCustomFieldTypeUpdateRequest(templateCustomFieldTypeName string, updateRequest http.TemplateCustomFieldType) error {
	ret := _m.Called(templateCustomFieldTypeName, updateRequest)

	var r0 error
	if rf, ok := ret.Get(0).(func(string, http.TemplateCustomFieldType) error); ok {
		r0 = rf(templateCustomFieldTypeName, updateRequest)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateDeletionRequest provides a mock function with given fields: templateID
func (_m *Session) ValidateTemplateDeletionRequest(templateID common.ID) error {
	ret := _m.Called(templateID)

	var r0 error
	if rf, ok := ret.Get(0).(func(common.ID) error); ok {
		r0 = rf(templateID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateImportRequest provides a mock function with given fields: importRequest, credentialID
func (_m *Session) ValidateTemplateImportRequest(importRequest http.Template, credentialID string) error {
	ret := _m.Called(importRequest, credentialID)

	var r0 error
	if rf, ok := ret.Get(0).(func(http.Template, string) error); ok {
		r0 = rf(importRequest, credentialID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateSyncRequest provides a mock function with given fields: templateID, credentialID
func (_m *Session) ValidateTemplateSyncRequest(templateID common.ID, credentialID string) error {
	ret := _m.Called(templateID, credentialID)

	var r0 error
	if rf, ok := ret.Get(0).(func(common.ID, string) error); ok {
		r0 = rf(templateID, credentialID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateTypeCreationRequest provides a mock function with given fields: creationRequest
func (_m *Session) ValidateTemplateTypeCreationRequest(creationRequest http.TemplateType) error {
	ret := _m.Called(creationRequest)

	var r0 error
	if rf, ok := ret.Get(0).(func(http.TemplateType) error); ok {
		r0 = rf(creationRequest)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateTypeDeletionRequest provides a mock function with given fields: templateTypeName
func (_m *Session) ValidateTemplateTypeDeletionRequest(templateTypeName service.TemplateTypeName) error {
	ret := _m.Called(templateTypeName)

	var r0 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName) error); ok {
		r0 = rf(templateTypeName)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateTypeUpdateFieldsRequest provides a mock function with given fields: templateTypeName, updateRequest, updateFields
func (_m *Session) ValidateTemplateTypeUpdateFieldsRequest(templateTypeName service.TemplateTypeName, updateRequest http.TemplateType, updateFields []string) error {
	ret := _m.Called(templateTypeName, updateRequest, updateFields)

	var r0 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName, http.TemplateType, []string) error); ok {
		r0 = rf(templateTypeName, updateRequest, updateFields)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateTypeUpdateRequest provides a mock function with given fields: templateTypeName, updateRequest
func (_m *Session) ValidateTemplateTypeUpdateRequest(templateTypeName service.TemplateTypeName, updateRequest http.TemplateType) error {
	ret := _m.Called(templateTypeName, updateRequest)

	var r0 error
	if rf, ok := ret.Get(0).(func(service.TemplateTypeName, http.TemplateType) error); ok {
		r0 = rf(templateTypeName, updateRequest)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateUpdateFieldsRequest provides a mock function with given fields: templateID, updateRequest, updateFields
func (_m *Session) ValidateTemplateUpdateFieldsRequest(templateID common.ID, updateRequest http.Template, updateFields []string) error {
	ret := _m.Called(templateID, updateRequest, updateFields)

	var r0 error
	if rf, ok := ret.Get(0).(func(common.ID, http.Template, []string) error); ok {
		r0 = rf(templateID, updateRequest, updateFields)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ValidateTemplateUpdateRequest provides a mock function with given fields: templateID, updateRequest
func (_m *Session) ValidateTemplateUpdateRequest(templateID common.ID, updateRequest http.Template) error {
	ret := _m.Called(templateID, updateRequest)

	var r0 error
	if rf, ok := ret.Get(0).(func(common.ID, http.Template) error); ok {
		r0 = rf(templateID, updateRequest)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewSession creates a new instance of Session. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewSession(t interface {
	mock.TestingT
	Cleanup(func())
}) *Session {
	mock := &Session{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
